<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPaymentMeanSuspensionDate ArrayType
 * @subpackage Arrays
 */
class ArrayOfPaymentMeanSuspensionDate extends AbstractStructArrayBase
{
    /**
     * The PaymentMeanSuspensionDate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PaymentMeanSuspensionDate[]
     */
    public $PaymentMeanSuspensionDate;
    /**
     * Constructor method for ArrayOfPaymentMeanSuspensionDate
     * @uses ArrayOfPaymentMeanSuspensionDate::setPaymentMeanSuspensionDate()
     * @param \StructType\PaymentMeanSuspensionDate[] $paymentMeanSuspensionDate
     */
    public function __construct(array $paymentMeanSuspensionDate = array())
    {
        $this
            ->setPaymentMeanSuspensionDate($paymentMeanSuspensionDate);
    }
    /**
     * Get PaymentMeanSuspensionDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PaymentMeanSuspensionDate[]|null
     */
    public function getPaymentMeanSuspensionDate()
    {
        return isset($this->PaymentMeanSuspensionDate) ? $this->PaymentMeanSuspensionDate : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPaymentMeanSuspensionDate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaymentMeanSuspensionDate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaymentMeanSuspensionDateForArrayConstraintsFromSetPaymentMeanSuspensionDate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPaymentMeanSuspensionDatePaymentMeanSuspensionDateItem) {
            // validation for constraint: itemType
            if (!$arrayOfPaymentMeanSuspensionDatePaymentMeanSuspensionDateItem instanceof \StructType\PaymentMeanSuspensionDate) {
                $invalidValues[] = is_object($arrayOfPaymentMeanSuspensionDatePaymentMeanSuspensionDateItem) ? get_class($arrayOfPaymentMeanSuspensionDatePaymentMeanSuspensionDateItem) : sprintf('%s(%s)', gettype($arrayOfPaymentMeanSuspensionDatePaymentMeanSuspensionDateItem), var_export($arrayOfPaymentMeanSuspensionDatePaymentMeanSuspensionDateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PaymentMeanSuspensionDate property can only contain items of type \StructType\PaymentMeanSuspensionDate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PaymentMeanSuspensionDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentMeanSuspensionDate[] $paymentMeanSuspensionDate
     * @return \ArrayType\ArrayOfPaymentMeanSuspensionDate
     */
    public function setPaymentMeanSuspensionDate(array $paymentMeanSuspensionDate = array())
    {
        // validation for constraint: array
        if ('' !== ($paymentMeanSuspensionDateArrayErrorMessage = self::validatePaymentMeanSuspensionDateForArrayConstraintsFromSetPaymentMeanSuspensionDate($paymentMeanSuspensionDate))) {
            throw new \InvalidArgumentException($paymentMeanSuspensionDateArrayErrorMessage, __LINE__);
        }
        if (is_null($paymentMeanSuspensionDate) || (is_array($paymentMeanSuspensionDate) && empty($paymentMeanSuspensionDate))) {
            unset($this->PaymentMeanSuspensionDate);
        } else {
            $this->PaymentMeanSuspensionDate = $paymentMeanSuspensionDate;
        }
        return $this;
    }
    /**
     * Add item to PaymentMeanSuspensionDate value
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentMeanSuspensionDate $item
     * @return \ArrayType\ArrayOfPaymentMeanSuspensionDate
     */
    public function addToPaymentMeanSuspensionDate(\StructType\PaymentMeanSuspensionDate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaymentMeanSuspensionDate) {
            throw new \InvalidArgumentException(sprintf('The PaymentMeanSuspensionDate property can only contain items of type \StructType\PaymentMeanSuspensionDate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PaymentMeanSuspensionDate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PaymentMeanSuspensionDate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PaymentMeanSuspensionDate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PaymentMeanSuspensionDate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PaymentMeanSuspensionDate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PaymentMeanSuspensionDate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PaymentMeanSuspensionDate
     */
    public function getAttributeName()
    {
        return 'PaymentMeanSuspensionDate';
    }
}
