<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetLastMinuteOffers StructType
 * @subpackage Structs
 */
class GetLastMinuteOffers extends AbstractStructBase
{
    /**
     * The lang
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $lang;
    /**
     * The user
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\WSUser
     */
    public $user;
    /**
     * The establishmentFilter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\EstablishmentFilter
     */
    public $establishmentFilter;
    /**
     * The productFilter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ProductFilter
     */
    public $productFilter;
    /**
     * The geographicalFilter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\GeographicalFilter
     */
    public $geographicalFilter;
    /**
     * The dateFilter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateFilter
     */
    public $dateFilter;
    /**
     * The specialOfferFilter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SpecialOfferFilter
     */
    public $specialOfferFilter;
    /**
     * The resultInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ResultInfo
     */
    public $resultInfo;
    /**
     * Constructor method for GetLastMinuteOffers
     * @uses GetLastMinuteOffers::setLang()
     * @uses GetLastMinuteOffers::setUser()
     * @uses GetLastMinuteOffers::setEstablishmentFilter()
     * @uses GetLastMinuteOffers::setProductFilter()
     * @uses GetLastMinuteOffers::setGeographicalFilter()
     * @uses GetLastMinuteOffers::setDateFilter()
     * @uses GetLastMinuteOffers::setSpecialOfferFilter()
     * @uses GetLastMinuteOffers::setResultInfo()
     * @param string $lang
     * @param \StructType\WSUser $user
     * @param \StructType\EstablishmentFilter $establishmentFilter
     * @param \StructType\ProductFilter $productFilter
     * @param \StructType\GeographicalFilter $geographicalFilter
     * @param \StructType\DateFilter $dateFilter
     * @param \StructType\SpecialOfferFilter $specialOfferFilter
     * @param \StructType\ResultInfo $resultInfo
     */
    public function __construct($lang = null, \StructType\WSUser $user = null, \StructType\EstablishmentFilter $establishmentFilter = null, \StructType\ProductFilter $productFilter = null, \StructType\GeographicalFilter $geographicalFilter = null, \StructType\DateFilter $dateFilter = null, \StructType\SpecialOfferFilter $specialOfferFilter = null, \StructType\ResultInfo $resultInfo = null)
    {
        $this
            ->setLang($lang)
            ->setUser($user)
            ->setEstablishmentFilter($establishmentFilter)
            ->setProductFilter($productFilter)
            ->setGeographicalFilter($geographicalFilter)
            ->setDateFilter($dateFilter)
            ->setSpecialOfferFilter($specialOfferFilter)
            ->setResultInfo($resultInfo);
    }
    /**
     * Get lang value
     * @return string
     */
    public function getLang()
    {
        return $this->lang;
    }
    /**
     * Set lang value
     * @uses \EnumType\Lang::valueIsValid()
     * @uses \EnumType\Lang::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $lang
     * @return \StructType\GetLastMinuteOffers
     */
    public function setLang($lang = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\Lang::valueIsValid($lang)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\Lang', is_array($lang) ? implode(', ', $lang) : var_export($lang, true), implode(', ', \EnumType\Lang::getValidValues())), __LINE__);
        }
        $this->lang = $lang;
        return $this;
    }
    /**
     * Get user value
     * @return \StructType\WSUser|null
     */
    public function getUser()
    {
        return $this->user;
    }
    /**
     * Set user value
     * @param \StructType\WSUser $user
     * @return \StructType\GetLastMinuteOffers
     */
    public function setUser(\StructType\WSUser $user = null)
    {
        $this->user = $user;
        return $this;
    }
    /**
     * Get establishmentFilter value
     * @return \StructType\EstablishmentFilter|null
     */
    public function getEstablishmentFilter()
    {
        return $this->establishmentFilter;
    }
    /**
     * Set establishmentFilter value
     * @param \StructType\EstablishmentFilter $establishmentFilter
     * @return \StructType\GetLastMinuteOffers
     */
    public function setEstablishmentFilter(\StructType\EstablishmentFilter $establishmentFilter = null)
    {
        $this->establishmentFilter = $establishmentFilter;
        return $this;
    }
    /**
     * Get productFilter value
     * @return \StructType\ProductFilter|null
     */
    public function getProductFilter()
    {
        return $this->productFilter;
    }
    /**
     * Set productFilter value
     * @param \StructType\ProductFilter $productFilter
     * @return \StructType\GetLastMinuteOffers
     */
    public function setProductFilter(\StructType\ProductFilter $productFilter = null)
    {
        $this->productFilter = $productFilter;
        return $this;
    }
    /**
     * Get geographicalFilter value
     * @return \StructType\GeographicalFilter|null
     */
    public function getGeographicalFilter()
    {
        return $this->geographicalFilter;
    }
    /**
     * Set geographicalFilter value
     * @param \StructType\GeographicalFilter $geographicalFilter
     * @return \StructType\GetLastMinuteOffers
     */
    public function setGeographicalFilter(\StructType\GeographicalFilter $geographicalFilter = null)
    {
        $this->geographicalFilter = $geographicalFilter;
        return $this;
    }
    /**
     * Get dateFilter value
     * @return \StructType\DateFilter|null
     */
    public function getDateFilter()
    {
        return $this->dateFilter;
    }
    /**
     * Set dateFilter value
     * @param \StructType\DateFilter $dateFilter
     * @return \StructType\GetLastMinuteOffers
     */
    public function setDateFilter(\StructType\DateFilter $dateFilter = null)
    {
        $this->dateFilter = $dateFilter;
        return $this;
    }
    /**
     * Get specialOfferFilter value
     * @return \StructType\SpecialOfferFilter|null
     */
    public function getSpecialOfferFilter()
    {
        return $this->specialOfferFilter;
    }
    /**
     * Set specialOfferFilter value
     * @param \StructType\SpecialOfferFilter $specialOfferFilter
     * @return \StructType\GetLastMinuteOffers
     */
    public function setSpecialOfferFilter(\StructType\SpecialOfferFilter $specialOfferFilter = null)
    {
        $this->specialOfferFilter = $specialOfferFilter;
        return $this;
    }
    /**
     * Get resultInfo value
     * @return \StructType\ResultInfo|null
     */
    public function getResultInfo()
    {
        return $this->resultInfo;
    }
    /**
     * Set resultInfo value
     * @param \StructType\ResultInfo $resultInfo
     * @return \StructType\GetLastMinuteOffers
     */
    public function setResultInfo(\StructType\ResultInfo $resultInfo = null)
    {
        $this->resultInfo = $resultInfo;
        return $this;
    }
}
