<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for searchAlternativeReason StructType
 * @subpackage Structs
 */
class SearchAlternativeReason extends AbstractStructBase
{
    /**
     * The notAvailable
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $notAvailable;
    /**
     * The isDiscontinueStayPossible
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $isDiscontinueStayPossible;
    /**
     * The startDurationConditionValue
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $startDurationConditionValue;
    /**
     * The startMaxDuration
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $startMaxDuration;
    /**
     * The endDurationConditionValue
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $endDurationConditionValue;
    /**
     * The endMaxDuration
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $endMaxDuration;
    /**
     * The allowedStartDays
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfDayOfWeek
     */
    public $allowedStartDays;
    /**
     * The allowedEndDays
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfDayOfWeek
     */
    public $allowedEndDays;
    /**
     * The startDurationConditionKind
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $startDurationConditionKind;
    /**
     * The endDurationConditionKind
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $endDurationConditionKind;
    /**
     * Constructor method for searchAlternativeReason
     * @uses SearchAlternativeReason::setNotAvailable()
     * @uses SearchAlternativeReason::setIsDiscontinueStayPossible()
     * @uses SearchAlternativeReason::setStartDurationConditionValue()
     * @uses SearchAlternativeReason::setStartMaxDuration()
     * @uses SearchAlternativeReason::setEndDurationConditionValue()
     * @uses SearchAlternativeReason::setEndMaxDuration()
     * @uses SearchAlternativeReason::setAllowedStartDays()
     * @uses SearchAlternativeReason::setAllowedEndDays()
     * @uses SearchAlternativeReason::setStartDurationConditionKind()
     * @uses SearchAlternativeReason::setEndDurationConditionKind()
     * @param bool $notAvailable
     * @param bool $isDiscontinueStayPossible
     * @param int $startDurationConditionValue
     * @param int $startMaxDuration
     * @param int $endDurationConditionValue
     * @param int $endMaxDuration
     * @param \ArrayType\ArrayOfDayOfWeek $allowedStartDays
     * @param \ArrayType\ArrayOfDayOfWeek $allowedEndDays
     * @param string $startDurationConditionKind
     * @param string $endDurationConditionKind
     */
    public function __construct($notAvailable = null, $isDiscontinueStayPossible = null, $startDurationConditionValue = null, $startMaxDuration = null, $endDurationConditionValue = null, $endMaxDuration = null, \ArrayType\ArrayOfDayOfWeek $allowedStartDays = null, \ArrayType\ArrayOfDayOfWeek $allowedEndDays = null, $startDurationConditionKind = null, $endDurationConditionKind = null)
    {
        $this
            ->setNotAvailable($notAvailable)
            ->setIsDiscontinueStayPossible($isDiscontinueStayPossible)
            ->setStartDurationConditionValue($startDurationConditionValue)
            ->setStartMaxDuration($startMaxDuration)
            ->setEndDurationConditionValue($endDurationConditionValue)
            ->setEndMaxDuration($endMaxDuration)
            ->setAllowedStartDays($allowedStartDays)
            ->setAllowedEndDays($allowedEndDays)
            ->setStartDurationConditionKind($startDurationConditionKind)
            ->setEndDurationConditionKind($endDurationConditionKind);
    }
    /**
     * Get notAvailable value
     * @return bool
     */
    public function getNotAvailable()
    {
        return $this->notAvailable;
    }
    /**
     * Set notAvailable value
     * @param bool $notAvailable
     * @return \StructType\SearchAlternativeReason
     */
    public function setNotAvailable($notAvailable = null)
    {
        // validation for constraint: boolean
        if (!is_null($notAvailable) && !is_bool($notAvailable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($notAvailable, true), gettype($notAvailable)), __LINE__);
        }
        $this->notAvailable = $notAvailable;
        return $this;
    }
    /**
     * Get isDiscontinueStayPossible value
     * @return bool
     */
    public function getIsDiscontinueStayPossible()
    {
        return $this->isDiscontinueStayPossible;
    }
    /**
     * Set isDiscontinueStayPossible value
     * @param bool $isDiscontinueStayPossible
     * @return \StructType\SearchAlternativeReason
     */
    public function setIsDiscontinueStayPossible($isDiscontinueStayPossible = null)
    {
        // validation for constraint: boolean
        if (!is_null($isDiscontinueStayPossible) && !is_bool($isDiscontinueStayPossible)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isDiscontinueStayPossible, true), gettype($isDiscontinueStayPossible)), __LINE__);
        }
        $this->isDiscontinueStayPossible = $isDiscontinueStayPossible;
        return $this;
    }
    /**
     * Get startDurationConditionValue value
     * @return int
     */
    public function getStartDurationConditionValue()
    {
        return $this->startDurationConditionValue;
    }
    /**
     * Set startDurationConditionValue value
     * @param int $startDurationConditionValue
     * @return \StructType\SearchAlternativeReason
     */
    public function setStartDurationConditionValue($startDurationConditionValue = null)
    {
        // validation for constraint: int
        if (!is_null($startDurationConditionValue) && !(is_int($startDurationConditionValue) || ctype_digit($startDurationConditionValue))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($startDurationConditionValue, true), gettype($startDurationConditionValue)), __LINE__);
        }
        $this->startDurationConditionValue = $startDurationConditionValue;
        return $this;
    }
    /**
     * Get startMaxDuration value
     * @return int
     */
    public function getStartMaxDuration()
    {
        return $this->startMaxDuration;
    }
    /**
     * Set startMaxDuration value
     * @param int $startMaxDuration
     * @return \StructType\SearchAlternativeReason
     */
    public function setStartMaxDuration($startMaxDuration = null)
    {
        // validation for constraint: int
        if (!is_null($startMaxDuration) && !(is_int($startMaxDuration) || ctype_digit($startMaxDuration))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($startMaxDuration, true), gettype($startMaxDuration)), __LINE__);
        }
        $this->startMaxDuration = $startMaxDuration;
        return $this;
    }
    /**
     * Get endDurationConditionValue value
     * @return int
     */
    public function getEndDurationConditionValue()
    {
        return $this->endDurationConditionValue;
    }
    /**
     * Set endDurationConditionValue value
     * @param int $endDurationConditionValue
     * @return \StructType\SearchAlternativeReason
     */
    public function setEndDurationConditionValue($endDurationConditionValue = null)
    {
        // validation for constraint: int
        if (!is_null($endDurationConditionValue) && !(is_int($endDurationConditionValue) || ctype_digit($endDurationConditionValue))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($endDurationConditionValue, true), gettype($endDurationConditionValue)), __LINE__);
        }
        $this->endDurationConditionValue = $endDurationConditionValue;
        return $this;
    }
    /**
     * Get endMaxDuration value
     * @return int
     */
    public function getEndMaxDuration()
    {
        return $this->endMaxDuration;
    }
    /**
     * Set endMaxDuration value
     * @param int $endMaxDuration
     * @return \StructType\SearchAlternativeReason
     */
    public function setEndMaxDuration($endMaxDuration = null)
    {
        // validation for constraint: int
        if (!is_null($endMaxDuration) && !(is_int($endMaxDuration) || ctype_digit($endMaxDuration))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($endMaxDuration, true), gettype($endMaxDuration)), __LINE__);
        }
        $this->endMaxDuration = $endMaxDuration;
        return $this;
    }
    /**
     * Get allowedStartDays value
     * @return \ArrayType\ArrayOfDayOfWeek|null
     */
    public function getAllowedStartDays()
    {
        return $this->allowedStartDays;
    }
    /**
     * Set allowedStartDays value
     * @param \ArrayType\ArrayOfDayOfWeek $allowedStartDays
     * @return \StructType\SearchAlternativeReason
     */
    public function setAllowedStartDays(\ArrayType\ArrayOfDayOfWeek $allowedStartDays = null)
    {
        $this->allowedStartDays = $allowedStartDays;
        return $this;
    }
    /**
     * Get allowedEndDays value
     * @return \ArrayType\ArrayOfDayOfWeek|null
     */
    public function getAllowedEndDays()
    {
        return $this->allowedEndDays;
    }
    /**
     * Set allowedEndDays value
     * @param \ArrayType\ArrayOfDayOfWeek $allowedEndDays
     * @return \StructType\SearchAlternativeReason
     */
    public function setAllowedEndDays(\ArrayType\ArrayOfDayOfWeek $allowedEndDays = null)
    {
        $this->allowedEndDays = $allowedEndDays;
        return $this;
    }
    /**
     * Get startDurationConditionKind value
     * @return string|null
     */
    public function getStartDurationConditionKind()
    {
        return $this->startDurationConditionKind;
    }
    /**
     * Set startDurationConditionKind value
     * @param string $startDurationConditionKind
     * @return \StructType\SearchAlternativeReason
     */
    public function setStartDurationConditionKind($startDurationConditionKind = null)
    {
        // validation for constraint: string
        if (!is_null($startDurationConditionKind) && !is_string($startDurationConditionKind)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startDurationConditionKind, true), gettype($startDurationConditionKind)), __LINE__);
        }
        $this->startDurationConditionKind = $startDurationConditionKind;
        return $this;
    }
    /**
     * Get endDurationConditionKind value
     * @return string|null
     */
    public function getEndDurationConditionKind()
    {
        return $this->endDurationConditionKind;
    }
    /**
     * Set endDurationConditionKind value
     * @param string $endDurationConditionKind
     * @return \StructType\SearchAlternativeReason
     */
    public function setEndDurationConditionKind($endDurationConditionKind = null)
    {
        // validation for constraint: string
        if (!is_null($endDurationConditionKind) && !is_string($endDurationConditionKind)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endDurationConditionKind, true), gettype($endDurationConditionKind)), __LINE__);
        }
        $this->endDurationConditionKind = $endDurationConditionKind;
        return $this;
    }
}
